%define pkg       pgpool

%define unam      postgres
%define uid       26


Summary:          A connection pooling/replication server for PostgreSQL
Name:             %{pkg}-II
Version:          2.3.1
Release:          1%{?dist}%{?pext}
License:          BSD
Group:            System Environment/Daemons
Source0:          http://pgfoundry.org/frs/download.php/2191/%{name}-%{version}.tar.gz
Source1:          %{pkg}.init
Source2:          %{pkg}.sysconfig
Source3:          %{pkg}.logrotate
URL:              http://pgfoundry.org/projects/%{pkg}/
Buildroot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:           PgPool Global Development Group
Requires:         libpcp = %{version}-%{release}
Requires(pre):    /usr/sbin/groupadd /usr/sbin/useradd
Requires(post):   /sbin/chkconfig
Requires(preun):  /sbin/chkconfig /sbin/service
Requires(postun): /sbin/service
BuildRequires:    pam-devel postgresql-devel

%description
PgPool-II is a middleware between PostgreSQL database servers and clients.
It features Connection Pooling, Replication and Load Balancing. It talks
both PostgreSQL's backend and frontend protocol, and relays a connection
transparently between server and client.


%package       -n libpcp
Summary:          The PgPool control library
Group:            System Environment/Libraries

%description   -n libpcp
The libpcp package contains the control library to manage PgPool.


%package       -n libpcp-devel
Summary:          Development tools for libpcp
Group:            Development/Libraries
Requires:         libpcp = %{version}-%{release}
Requires:         pam-devel

%description   -n libpcp-devel
The libpcp-devel package contains the static libraries and header files
for developing software using PgPool.


%prep
%setup -q


%build
%configure \
	--sysconfdir=%{_sysconfdir}/%{name} \
	--enable-shared                     \
	--enable-static                     \
	--with-pam

%{__make} %{?_smp_mflags}


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_initrddir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/{logrotate.d,sysconfig}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sbindir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_localstatedir}/{log,run}/%{pkg}

%{__make} \
	DESTDIR=${RPM_BUILD_ROOT} \
	install

%{__mv}      -f      ${RPM_BUILD_ROOT}%{_bindir}/%{pkg} ${RPM_BUILD_ROOT}%{_sbindir}

%{__install} -m 0755 %{SOURCE1}          ${RPM_BUILD_ROOT}%{_initrddir}/%{pkg}
%{__install} -m 0644 %{SOURCE2}          ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/%{pkg}
%{__install} -m 0644 %{SOURCE3}          ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{pkg}

for CONF in pcp.conf pgpool.conf pool_hba.conf; do
  %{__cp}            ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/${CONF}.sample \
		     ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/${CONF}
done

%{__cp}      -r      sample              ${RPM_BUILD_ROOT}%{_datadir}/%{name}
%{__cp}      -r      sql/%{pkg}-recovery ${RPM_BUILD_ROOT}%{_datadir}/%{name}/recovery

touch                ${RPM_BUILD_ROOT}%{_localstatedir}/log/%{pkg}/pgpool_status

%{__rm}      -f      ${RPM_BUILD_ROOT}%{_libdir}/lib*.so.{?,??}
%{__rm}      -f      ${RPM_BUILD_ROOT}%{_datadir}/%{name}/sample/%{pkg}.pam


%pre
if ! getent group  %{unam} >/dev/null 2>&1; then
  /usr/sbin/groupadd -r -g %{uid} %{unam}
fi
if ! getent passwd %{unam} >/dev/null 2>&1; then
  /usr/sbin/useradd  -r -u %{uid} -g %{unam} \
	-d %{_localstatedir}/lib/pgsql       \
	-c "PostgreSQL Server"               \
	-s /bin/bash %{unam}

  %{__mkdir_p}               %{_localstatedir}/lib/pgsql
  %{__chown} %{unam}:%{unam} %{_localstatedir}/lib/pgsql
  %{__chmod} 0700            %{_localstatedir}/lib/pgsql
fi
exit 0			# Always pass


%post
/sbin/chkconfig --add %{pkg}

%post -n libpcp -p /sbin/ldconfig


%preun
if [ $1 -eq 0 ]; then	# Remove
  /sbin/service %{pkg} stop >/dev/null 2>&1
  /sbin/chkconfig --del %{pkg}
fi


%postun
if [ $1 -ge 1 ]; then	# Upgrade
  /sbin/service %{pkg} condrestart >/dev/null 2>&1 || :
fi

%postun -n libpcp -p /sbin/ldconfig


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog INSTALL NEWS README
%doc TODO doc
%{_initrddir}/%{pkg}
%config(noreplace) %{_sysconfdir}/logrotate.d/%{pkg}
%config(noreplace) %{_sysconfdir}/sysconfig/%{pkg}
%attr(750,root,%{unam}) %dir %{_sysconfdir}/%{name}
%attr(640,root,%{unam}) %config(noreplace) %{_sysconfdir}/%{name}/pcp.conf
%attr(640,root,%{unam}) %config(noreplace) %{_sysconfdir}/%{name}/%{pkg}.conf
%attr(640,root,%{unam}) %config(noreplace) %{_sysconfdir}/%{name}/pool_hba.conf
%{_sysconfdir}/%{name}/*.sample*
%{_bindir}/pcp_attach_node
%{_bindir}/pcp_detach_node
%{_bindir}/pcp_node_count
%{_bindir}/pcp_node_info
%{_bindir}/pcp_proc_count
%{_bindir}/pcp_proc_info
%{_bindir}/pcp_recovery_node
%{_bindir}/pcp_stop_pgpool
%{_bindir}/pcp_systemdb_info
%{_bindir}/pg_md5
%{_sbindir}/%{pkg}
%{_datadir}/%{name}
%{_mandir}/man8/%{pkg}.8*
%attr(750,%{unam},%{unam}) %dir %{_localstatedir}/log/%{pkg}
%attr(750,%{unam},%{unam}) %dir %{_localstatedir}/run/%{pkg}
%attr(640,%{unam},%{unam}) %ghost %{_localstatedir}/log/%{pkg}/pgpool_status

%files -n libpcp
%defattr(-,root,root)
%{_libdir}/libpcp.so.*

%files -n libpcp-devel
%defattr(-,root,root)
%{_includedir}/pcp.h
%{_includedir}/pool_type.h
%{_libdir}/libpcp.*a
%{_libdir}/libpcp.so


%changelog
* Thu Jan 07 2010 Peter Pramberger <peterpramb@member.fsf.org> - 2.3.1-1
- Upgrade version (2.3.1)

* Fri Dec 04 2009 Peter Pramberger <peterpramb@member.fsf.org> - 2.2.6-1
- New version (2.2.6)

* Thu Oct 08 2009 Peter Pramberger <peterpramb@member.fsf.org> - 2.2.5-1
- New version (2.2.5)

* Fri Aug 28 2009 Peter Pramberger <peterpramb@member.fsf.org> - 2.2.4-1
- New version (2.2.4)

* Wed Aug 19 2009 Peter Pramberger <peterpramb@member.fsf.org> - 2.2.3-1
- New version (2.2.3)

* Wed May 06 2009 Peter Pramberger <peterpramb@member.fsf.org> - 2.2.2-1
- Initial build
